package L8_JUnit.tests;
/**
 * These samples are simplified versions of the project available on the class 
 * "Kompetens szoftvertesztelés a gyakorlatban" https://w1.inf.unideb.hu/dtk/costip (in hungarian)
 */
import L8_JUnit.model.UnderTestService;
import L8_JUnit.model.UnderTestServiceImpl;
import org.junit.*;

public class Test004LifeCycle {
    private static UnderTestService underTestService;
    @BeforeClass
    public static void beforeTestClass() {
        System.out.println("Runs ones before test all tests in class");
        underTestService = new UnderTestServiceImpl();
    }
    @Before
    public void beforeAllTests() {
        System.out.println("Runs before each test");
        if(underTestService==null) Assert.fail(
                "The service become unavailable before the test");
    }
    @Test
    public void testMe() {
        System.out.println("testMe");
        underTestService.getFooObject(10);
        //underTestService=null; //Why is this statement wrong???
    }
    @Test
    public void testMeToo() {
        System.out.println("testMeToo");
        underTestService.getFooObject(11);
    }
    @After
    public void afterAllTests() {
        System.out.println("Runs after each test");
        if(underTestService==null) Assert.fail(
                "The service become unavailable after the test");
    }
    @AfterClass
    public static void afterTestClass() {
        System.out.println("Runs ones after test all tests in class");
        underTestService = null;
    }
}
